unit Module;
interface
uses windows, sysutils, controls, stdctrls, graphics, Gauges,
     dialogs, iniFiles, messages;

procedure Compte_les_disques;
procedure Creation_Barres_et_Labels;
procedure Compare_les_taillesmax;
procedure Recupere_espace_occupe;
procedure Adapte_les_barres;
procedure Recupere_taille_disque;
procedure sauve_taille_et_position;

var
  Labeldisque: array [0..23] of Tlabel; //  Labeldisque: Tlabel; // prev vers
  Gaugebarre : array [0..23] of TGauge;
  table_type : array [0..23] of integer;
  Nbredisque : byte;
  drive : string;
  Repertoire : array [0..255] of Char;
  NomVolume : array[0..255] of Char;
  NumSerie : DWORD;
  LongueurMaxNomFichier : DWORD;
  TypeCase : DWORD;
  FileSystem : array[0..255] of Char;

implementation

uses DiskSpaceKludge, Unit1;

var
  numerodisquemax : byte;
  maxibarre : integer;
  Tailledisque : Array [0..23] of Comp;
  Tailleoccupe : Array [0..23] of Comp;
  Taille_libre : Array [0..23] of Comp;
  Taillemaxi : Comp;

procedure Compte_les_disques;
var i : byte;
TypeDrive : string;
begin
  form1.liste_lecteurs.clear;
  Nbredisque := 0;
  for i := 2 to 25 do begin               // C to Z
    Drive := (Char(i + ord('A')) + ':\'); // tour  tour, on obtient 'C:\', 'D:\' etc.
    case GetDriveType(pChar(drive)) of    //permet d'obtenir le type du drive
      DRIVE_FIXED     : TypeDrive := 'Disque dur';
      DRIVE_CDROM     : TypeDrive := 'CD-ROM';
      DRIVE_RAMDISK   : TypeDrive := 'RAM Disk';
      DRIVE_REMOVABLE : TypeDrive := 'Lecteur de disquettes';
      DRIVE_REMOTE    : TypeDrive := 'Disque rseau';
      0               : TypeDrive := 'Lecteur inconnu';
      1               : TypeDrive := ''; //le lecteur n'existe pas;
    end;
    if (TypeDrive = 'Disque dur') or (TypeDrive = 'Disque rseau') then begin
      Table_type[Nbredisque] := i;
      form1.liste_lecteurs.add(copy(Drive, 1, 1));
      inc(Nbredisque);
    end;
  end;
end;

procedure Creation_Barres_et_Labels;
var i : byte;
begin
  for i := 0 to Nbredisque - 1 do begin
  // Rcupre les labels
  StrPcopy(Repertoire, form1.liste_lecteurs[i] + ':\');
  if not GetVolumeInformation(Repertoire, NomVolume, SizeOf(NomVolume), @NumSerie,
         LongueurMaxNomFichier, TypeCase, FileSystem, sizeOf(FileSystem))
     then ShowMessage('Erreur !...');

  Labeldisque[i] := Tlabel.Create(Form1);
  Labeldisque[i].Parent :=  Form1;
  Labeldisque[i].Font.name := 'Courier New';
  Labeldisque[i].Font.Size := 8;
  Labeldisque[i].Font.Color := $000000C0;
  Labeldisque[i].Caption := 'Disque ' + form1.liste_lecteurs[i] + ': ' + String(NomVolume);
  Labeldisque[i].Hint := 'Clic pour ouvrir';
  Labeldisque[i].Setbounds (8,  (17 * i + 14), 152,  17);
  //                       Left,    Top,      Width, Height

  Gaugebarre[i] := Tgauge.Create(Form1);
  Gaugebarre[i].Parent := Form1;
  Gaugebarre[i].ShowHint := true;
  Gaugebarre[i].Showtext := false;
  Gaugebarre[i].BackColor := clLime;
  Gaugebarre[i].Forecolor := $004080FF;
  Gaugebarre[i].SetBounds (160, ((17 * i) + 17), 57, 9);   // Width redimensionn plus bas
  end;
end;

procedure Recupere_taille_disque;
var i : byte;
begin
  For i := 0 To Nbredisque - 1 do
    Tailledisque[i] := round(DiskSpaceKludge.Disksize(Table_type[i] + 1)/1048576);
end;

procedure Compare_les_taillesmax;
var i : byte;
begin
  // cherche la taille maxi
  taillemaxi := 0;
  For i := 0 To Nbredisque - 1 do
    If Tailledisque[i] >= taillemaxi Then taillemaxi := Tailledisque[i];

  // cherche le disque avec maxtaille
  For i := 0 To Nbredisque - 1 do
    If Tailledisque[i] = taillemaxi Then begin
      numerodisquemax := i;
      exit;
    end;
end;

procedure Adapte_les_barres;
var i : byte;
begin
  maxibarre := taillefeuille - 210;
  For i := 0 To Nbredisque - 1 do begin
    Gaugebarre[i].Width := maxibarre *
        strtoint(copy(Format('%.0f', [Tailledisque[i]]),1 ,12)) div
           strtoint(copy(Format('%.0f', [Tailledisque[numerodisquemax]]),1 ,12));
    Gaugebarre[i].MaxValue := strtoint(copy(Format('%.0f', [Tailledisque[i]]),1 ,12));
    Gaugebarre[i].Progress := strtoint(copy(Format('%.0f', [Tailleoccupe[i]]),1 ,12));
    Gaugebarre[i].Hint :=
       'Occup : ' + copy(Format('%.0f', [Tailleoccupe[i]]),1 ,5) +
    ' -- Libre : ' + copy(Format('%.0f', [Taille_libre[i]]),1 ,5) +
    ' -- Total : ' + copy(Format('%.0f', [Tailledisque[i]]),1 ,5) + ' Mo ';
  end;
end;

procedure Recupere_espace_occupe;
var i : byte;
begin
  For i := 0 To Nbredisque - 1 do begin
    Tailleoccupe[i] := round(DiskSpaceKludge.Disksize(Table_type[i] + 1)/1048576) - round(DiskSpaceKludge.Diskfree(Table_type[i] + 1)/1048576);
    Taille_libre[i] := Tailledisque[i] - Tailleoccupe[i];
  end;
end;

procedure sauve_taille_et_position;
begin
  FIni:=TiniFile.Create(Fichier_ini);
  try
    FIni.WriteString('emplacement', 'gauche', inttostr(form1.left));
    FIni.WriteString('emplacement', 'haut', inttostr(form1.top));
    FIni.WriteString('emplacement', 'largeur', inttostr(form1.width));
    //FIni.WriteString('emplacement', 'hauteur', inttostr(form1.height)); // Inutile
  finally
  Fini.Free;
  end;
end;

END.
