unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, ShellAPI, Gauges, Menus, iniFiles,
  Module, Unit2;      //shellapi pour 'ShellExecute'

Const WM_MESSAGE = WM_USER + 100;  // Utilis par TrayMessage

type
  TForm1 = class(TForm)
    MainTimer: TTimer;
    MainMenu: TMainMenu;
    Fichier: TMenuItem;
    Cacher: TMenuItem;
    Aide: TMenuItem;
    Barre_separation: TGroupBox;
    Quitter: TMenuItem;
    Tiret: TMenuItem;
    Image1: TImage;
    Panel1: TPanel;
    Label2: TLabel;
    PopupMenu1: TPopupMenu;
    Clicpourfermer1: TMenuItem;
    tiret2: TMenuItem;
    Arreter: TMenuItem;
    Rebooter: TMenuItem;

    procedure QuitterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Main_Timer(Sender: TObject);
    procedure AideClick(Sender: TObject);
    procedure OneInstanceInstanceStarted(Sender: TObject; params: TStringList);
    procedure FormClick(Sender: TObject);
    procedure click_on_label(Sender: TObject);
    procedure ArreterClick(Sender: TObject);
    procedure RebooterClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
    procedure Traymessage(var Msg: Tmessage); message WM_MESSAGE;
  public
    { Dclarations publiques }
    liste_lecteurs : Tstrings;
    procedure WMSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
  end;

var
  Form1: TForm1;
  NotifyStruc : PNotifyIconData; // structure de l'icone
  taillefeuille : integer;
  s1 : string = ' Mmoire physique disponible : ';
  s2 : string = ' octets sur ';
  s3 : string = ' octets totaux, soit ';
  s4 : string = ' % libre. ';
  MS : TMemoryStatus;
  Fichier_ini : string;
  FIni : TiniFile;
  minimized : boolean = false;
  Fermer_tout : boolean = false;

function ExecuteFile(const FileName, Params, DefaultDir: string; ShowCmd: Integer): THandle;

implementation

{$R *.DFM}

var
  OldWindowProc : Pointer; {Variable for the old windows proc}
  MyMsg : DWord; {custom systemwide message}

function ExecuteFile(const FileName, Params, DefaultDir: string; ShowCmd: Integer): THandle;
// Utilis pour lancement des feuilles d'exploration
var
  zFileName, zParams, zDir: array[0..79] of Char;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
      StrPCopy(zDir, DefaultDir), ShowCmd);
end;

function NewWindowProc(WindowHandle : hWnd;
 TheMessage   : LongInt;
 ParamW       : LongInt;
 ParamL       : LongInt) : LongInt stdcall;
begin
  if TheMessage = MyMsg then begin
    //SendMessage(Application.handle, WM_SYSCOMMAND, SC_RESTORE, 0);
    ShowWindow(Form1.Handle, SW_RESTORE); // ligne prc. pas bonne si minimized
    form1.visible := true;   // ncessaire
    SetForegroundWindow(Application.Handle);
    Result := 0;
    exit;
  end;
  Result := CallWindowProc(OldWindowProc, WindowHandle, TheMessage, ParamW, ParamL);
end;

function Win32PlatForm : integer;
var
  OsVersion : TOSVersionInfo;
begin
  with OSVersion do begin
    dwOSVersionInfoSize := sizeof(OSVersion);
    GetVersionEx(OSVersion);
    result := dwMajorVersion;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i : byte;
begin
  MyMsg := RegisterWindowMessage('Mon_Appli');
  OldWindowProc := Pointer(SetWindowLong(Form1.Handle, GWL_WNDPROC, LongInt(@NewWindowProc)));

  // Contrle de la version de Windows (items Arreter et Rebooter du menu Pop
  // incompatibles avec W2000 [et NT 4 ? Non test])
  if Win32PlatForm <> 4 then begin  // 4 = W95 ou W98
    Arreter.visible := false;
    Rebooter.visible := false;
    tiret2.visible := false;
    end;

  // Cration de la petite icone
  New(NotifyStruc);
  NotifyStruc^.cbSize := Sizeof(NotifyStruc^);
  NotifyStruc^.Wnd := Handle;
  NotifyStruc^.uID := 1;
  NotifyStruc^.uFlags := NIF_ICON or NIF_TIP or NIF_MESSAGE;
  NotifyStruc^.uCallbackMessage := WM_MESSAGE;
  NotifyStruc^.hIcon := Form1.Image1.Picture.icon.Handle;
  NotifyStruc^.szTip := 'Clics gauches pour afficher/masquer, clic droit pour fermer';
  Shell_NotifyIcon(NIM_ADD, NotifyStruc);

  liste_lecteurs := Tstringlist.create;
  Compte_les_disques;
  Recupere_taille_disque;
  Compare_les_taillesmax;
  Creation_Barres_et_Labels;
  for i := 0 to Nbredisque - 1 do Labeldisque[i].OnClick := click_on_label;

  // Cration d'Infodisk.ini
  Fichier_ini := lowercase(ChangeFileExt(paramstr(0),'.ini'));
  FIni:=TiniFile.Create(Fichier_ini);
  try
    form1.left := strtoint(FIni.ReadString('emplacement', 'gauche', '15'));
    form1.top := strtoint(FIni.ReadString('emplacement', 'haut', '70'));
    form1.width := strtoint(FIni.ReadString('emplacement', 'largeur', inttostr(screen.width - 30)));
    //form1.height := strtoint(FIni.ReadString('emplacement', 'hauteur', '200')); // Inutile
  finally
    Fini.Free;
  end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  MainTimer.enabled := false;
  taillefeuille := form1.width;
  Barre_separation.width := taillefeuille - 10;
  form1.height := (17 * Nbredisque) + 70 + 20;
  MainTimer.enabled := true;
end;

procedure TForm1.Main_Timer(Sender: TObject);
var i, temp : byte; infototal, infolibre : comp;
begin
  // Infos mmoire :
  GlobalMemoryStatus(MS);
  infototal := MS.dwTotalPhys;
  infolibre := MS.dwAvailPhys;
  label2.caption := s1 + format('%.0n', [infolibre]) + s2 + format('%.0n', [infototal])
    + s3 + floattostrf(((100 * infolibre) / infototal), ffFixed, 3, 0) + s4;

  // Vrification du nombre de disques,
  // en cas de connexion/deconnexion de disques rseau
  temp := Nbredisque;
  Compte_les_disques;
  if temp <> Nbredisque then
    begin
       For i := 0 to temp - 1 do begin
       Gaugebarre[i].free;
       Labeldisque[i].free;
       end;
       form1.height := (17 * Nbredisque) + 70 + 20;
       Recupere_taille_disque;
       Compare_les_taillesmax;
       Creation_Barres_et_Labels;
       for i := 0 to Nbredisque - 1 do Labeldisque[i].OnClick := click_on_label;
    end;

  // Mise  jour des donnes d'affichage
  Recupere_espace_occupe;
  Adapte_les_barres;
  Application.ProcessMessages;
end;

procedure TForm1.FormClick(Sender: TObject);  // Cache la feuille
begin
  MainTimer.Enabled := false;
  hide;
end;

procedure TForm1.click_on_label(Sender: TObject);
var i : byte;
begin
  for i := 0 to Nbredisque do begin  // OK
    if sender = labeldisque[i] then begin
      executefile('explorer.exe', ' /root,' + liste_lecteurs[i] + ':\', '', SW_SHOW);
      exit;
    end;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  ShowWindow(Application.Handle, SW_HIDE); // cach dans barre des taches
  setforegroundwindow(Application.Handle);
  MainTimer.enabled := true;
end;

procedure TForm1.TrayMessage(var Msg: TMessage); // message WM_MYMESSAGE;
var coordonnees_souris : TPoint;
begin
  case Msg.LParam of
  // Bouton gauche, on affiche (ou masque) la feuille
     WM_LBUTTONDOWN :
       begin
         if minimized then begin
           ShowWindow(Form1.Handle, SW_RESTORE);  // passe  FormResize
           minimized := false;
           Form1.Visible := true; // Oblig de rajouter cette ligne, sinon
           // FormClick et Menu/Fichier/Cacher ne marchent pas aprs un minimize...
           exit;
         end;
         Form1.Visible := not Form1.Visible;
       end;
  // Bouton droit, on quitte
     WM_RBUTTONDOWN :      //WM_RBUTTONUP : close;   // Prev. vers.
       begin
         GetCursorPos(coordonnees_souris);
         SetForegroundWindow(Handle);
         PopupMenu1.Popup(coordonnees_souris.x, coordonnees_souris.y - 10);
       end;
  end;
  DefaultHandler(Msg); // Utile ? Pas utile ? Who knows ?...
end;

procedure TForm1.AideClick(Sender: TObject);
begin
  with TfrmHelp.Create(application) do
    try begin
      left := form1.left + 10;
      top := form1.top - 5;
      showmodal;
      end;
    finally free;
  end;
  // Attention : supprimer la fiche frmHelp des fiches  auto-crer dans
  // Projet / Options / Fiches
end;

procedure TForm1.OneInstanceInstanceStarted(Sender: TObject; params: TStringList);
begin
  show;
end;

procedure TForm1.QuitterClick(Sender: TObject);
begin
  Fermer_tout := true;
  close;
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var i : byte;
begin
  MainTimer.enabled := false;     // <<< ligne rajoute
  sauve_taille_et_position;
  if (NotifyStruc <> NIL) then Shell_NotifyIcon(NIM_DELETE, NotifyStruc);
  Dispose(NotifyStruc);
  liste_lecteurs.free;
  For i := 0 to Nbredisque - 1 do begin
    Labeldisque[i].free;
    Gaugebarre[i].free;
    end;
end;


procedure TForm1.WMSysCommand;  // Interception de Minimize
begin
  if Msg.CmdType = SC_MINIMIZE then begin
    minimized := true;
    MainTimer.enabled := false;
    hide;
  end;
  DefaultHandler(Msg);
end;

procedure TForm1.ArreterClick(Sender: TObject);
begin
  sauve_taille_et_position;
  ExitWindowsEx(ewx_shutdown, 0);
end;

procedure TForm1.RebooterClick(Sender: TObject);
begin
  sauve_taille_et_position;
  ExitWindowsEx(EWX_REBOOT, 0);
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
    MainTimer.enabled := false;
    hide;
  if Fermer_tout = true then CanClose := true else CanClose := false;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  SetWindowLong(Form1.Handle, GWL_WNDPROC, LongInt(OldWindowProc));
end;

END.
